//Emote_Snore.cs
//Go sit on an invisible brick with this emote as an emitter while AFK.


function serverCmdsnore(%client)

{

   if(isObject(%client.player))

      %client.player.emote(SnoreImage);

}

function doSnore()

{
  
   commandToServer('snore');

}

function snoreFix(%yn)
{
    if(%yn$="")
        %yn=0;
    %yn = !%yn;
    if(%yn==1)
        doSnore();
}


datablock ParticleData(SnoreParticle)

{

      dragCoefficient      = 5.0;

   gravityCoefficient   = -0.2;

   inheritedVelFactor   = 0.0;

   constantAcceleration = 0.0;

   lifetimeMS           = 5000;

   lifetimeVarianceMS   = 500;

   useInvAlpha          = true;

   textureName          = "./zz";

   colors[0]     = "1 1 1 1";

   colors[1]     = "1 1 1 1";

   colors[2]     = "1 1 1 1";

   sizes[0]      = 0.9;

   sizes[1]      = 1.0;

   sizes[2]      = 1.9;

   times[0]      = 3.0;

   times[1]      = 4.9;

   times[2]      = 5.0;

};



datablock ParticleEmitterData(SnoreEmitter)

{

   ejectionPeriodMS = 35;

   periodVarianceMS = 0;

   ejectionVelocity = 0.5;

   ejectionOffset   = 1.0;

   velocityVariance = 0.49;

   thetaMin         = 0;

   thetaMax         = 120;

   phiReferenceVel  = 0;

   phiVariance      = 360;

   overrideAdvance = false;

   lifeTimeMS = 200;

   particles = "SnoreParticle";



   uiName = "Emote - Zzzz";

};

datablock ShapeBaseImageData(SnoreImage)

{

        shapeFile = "base/data/shapes/empty.dts";

        emap = false;



        mountPoint = $HeadSlot;



        stateName[0]                                        = "Ready";

        stateTransitionOnTimeout[0]                = "FireA";

        stateTimeoutValue[0]                        = 0.01;



        stateName[1]                                        = "FireA";

        stateTransitionOnTimeout[1]                = "Done";

        stateWaitForTimeout[1]                        = True;

        stateTimeoutValue[1]                        = 0.350;

        stateEmitter[1]                                        = SnoreEmitter;

        stateEmitterTime[1]                                = 0.350;



        stateName[2]                                        = "Done";

        stateScript[2]                                        = "onDone";

};

function SnoreImage::onDone(%this,%obj,%slot)

{

        %obj.unMountImage(%slot);

}




//Stolen from Ephi, who stole it from Randy

function AddBind(%division, %name, %command)

{

        for(%i=0;%i<$remapCount;%i++)

        {

                if($remapDivision[%i] $= %division)

                {

                        %foundDiv = 1;

                        continue;

                }

                if(%foundDiv && $remapDivision[%i] !$= "")

                {

                        %position = %i;

                        break;

                }

        }

        if(!%foundDiv)

        {

                error("Division not found: " @ %division);

                return;

        }

        if(!%position)

        {

                $remapName[$remapCount] = %name;

                $remapCmd[$remapCount] = %command;

                $remapCount++;

                return;

        }

        for(%i=$remapCount;%i>%position;%i--)

        {

                $remapDivision[%i] = $remapDivision[%i - 1];

                $remapName[%i] = $remapName[%i - 1];

                $remapCmd[%i] = $remapCmd[%i - 1];

        }

        $remapDivision[%position] = "";

        $remapName[%position] = %name;

        $remapCmd[%position] = %command;

        $remapCount++;

}

if(!$addedSnoreEmoteBinds)

{

        AddBind("Emotes","Snore","snoreFix");

        $addedSnoreEmoteBinds = true;

}





